## qca2 2.3.1

=== debian/changelog ===
qca2 (2.3.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump libssl-dev to 1.1.1

 -- Pino Toscano <pino@debian.org>  Thu, 09 Jul 2020 07:57:50 +0200

qca2 (2.3.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Add the configuration for the CI on salsa.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.4
    - bump Qt5 to 5.6
  * Update the patches:
    - define_qca_export.diff: refresh
    - pipeunittest_more_wait.diff: refresh
    - hurd_msync.diff: refresh
    - kubuntu_ignore_filewatch_test.diff: refresh
  * Update symbols file.
  * Remove extra trailing whitespaces in changelog.
  * Small changes to copyright.
  * Use DEB_CFLAGS_MAINT_APPEND & DEB_CXXFLAGS_MAINT_APPEND to append the
    visibility build flags, instead of setting CFLAGS & CXXFLAGS directly.
  * Switch from dhmk to the dh sequencer:
    - call the right debhelper command instead of $(overridden_command)
    - manually force the generation of the strict shlibs handling
    - remove the overrides that do not do anything more than the command itself
  * Remove debian/not-installed, no more needed now.
  * Remove the unused 'testsuite' autopkgtest.
  * Update lintian overrides.
  * Add Rules-Requires-Root: no.
  * Build the documentation only in -indep builds:
    - move doxygen as Build-Depends-Indep
    - perform the normal build in dh_auto_build-arch, and only build the doc
      in dh_auto_build-indep
    - disable dh_auto_install-indep, and auto_test-indep, as there is nothing
      to do in these cases
  * Simplify libqca2-doc.install by installing the output directory as a whole
    - avoid shipping .md5 files
  * Add graphviz as Build-Depends-Indep to improve the generated HTML apidox.
  * Bump Standards-Version to 4.5.0, no changes required.
  * Add the upstream signing key.
  * Use /usr/share/dpkg/architecture.mk to get $DEB_HOST_MULTIARCH, instead
    of querying dpkg-architecture manually.

 -- Pino Toscano <pino@debian.org>  Sun, 05 Jul 2020 20:23:57 +0200

=== debian/control ===
Source: qca2
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Felix Geyer <fgeyer@debian.org>,
           Maximiliano Curia <maxy@debian.org>,
Build-Depends: ca-certificates,
               cmake (>= 3.4~),
               debhelper-compat (= 12),
               libsasl2-dev,
               libssl-dev (>= 1.1.1~),
               pkg-config,
               pkg-kde-tools (>= 0.15.16),
               qtbase5-dev (>= 5.6.0~),
Build-Depends-Indep: doxygen,
                     graphviz,
Build-Conflicts: libqca2-dev, qca-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://userbase.kde.org/QCA
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qca2.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qca2

Package: libqca-qt5-2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ca-certificates, libqca-qt5-2-plugins
Description: libraries for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.

Package: libqca-qt5-2-plugins
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: QCA plugins for libqca2
 This plugin provides cryptographic as well as helper plugins for Qt
 Cryptographic Architecture (QCA).

Package: qca-qt5-2-utils
Section: utils
Architecture: any
Depends: libqca-qt5-2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: command line tool for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains the command line tool for the Qt Cryptographic
 Architecture.

Package: libqca-qt5-2-dev
Section: libdevel
Architecture: any
Depends: libqca-qt5-2 (= ${binary:Version}), qtbase5-dev, ${misc:Depends}
Suggests: libqca2-doc (= ${source:Version})
Conflicts: qca-dev
Description: development files for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains development files for building software that uses the
 Qt Cryptographic Architecture.

Package: libqca2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: qt5-doc
Suggests: libqca-qt5-2-dev (>= ${source:Version})
Description: API documentation for the Qt Cryptographic Architecture
 The Qt Cryptographic Architecture (QCA) provides a straightforward and cross-
 platform API for a range of cryptographic features, including SSL/TLS,
 X.509 certificates, SASL, OpenPGP, S/MIME CMS, and smart cards.
 .
 This package contains documentation for developers working with the
 Qt Cryptographic Architecture.

## qca2 2.3.2

=== CMakeLists.txt ===
# Checking for user explicitly defined CMAKE_INSTALL_PREFIX
# It must be done before project(...)
if(NOT CMAKE_INSTALL_PREFIX)
  set(QCA_INSTALL_IN_QT_PREFIX ON)
  # If CMAKE_INSTALL_PREFIX is set in cmake arguments
  unset(CMAKE_INSTALL_PREFIX CACHE)
endif()

# The cmake min. version should be set before calling project(...) too
cmake_minimum_required(VERSION 3.4)

project(qca)

set(QCA_LIB_MAJOR_VERSION "2")
set(QCA_LIB_MINOR_VERSION "3")
set(QCA_LIB_PATCH_VERSION "2")

if(POLICY CMP0042)
  cmake_policy(SET CMP0042 OLD)
endif()

option(BUILD_TESTS "Create test" ON)
option(BUILD_TOOLS "Compile mozcerts and qcatool" ON)
set(BUILD_PLUGINS "auto" CACHE STRING "Plugins for building (also possible values: none, all and auto)")
# BUILD_SHARED_LIBS is cmake variable. Need to change default value.
option(BUILD_SHARED_LIBS "Build shared library" ON)
option(DEVELOPER_MODE "Special developer mode" OFF)

if(APPLE)
  option(OSX_FRAMEWORK "Build a Mac OS X Framework" ON)
else()
  set(OSX_FRAMEWORK OFF)
endif()

find_package(Doxygen)

string(TOLOWER "${BUILD_PLUGINS}" BUILD_PLUGINS)
if(NOT BUILD_PLUGINS)
  set(BUILD_PLUGINS "none")
endif()

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules" )

# Do not automatically link Qt executables to qtmain target on Windows.
# QCA exucatables use console mode only. Not need to link against qtmain.lib.
set(Qt5_NO_LINK_QTMAIN ON)
find_package(Qt5 5.9 REQUIRED Core)
set(CMAKE_AUTOMOC ON)

include(QcaMacro)
include(GNUInstallDirs)
setup_qt5_dirs()
set(QCA_QT_PC_VERSION "Qt5Core")
set(QCA_SUFFIX "qt5")

# QCA can be shared but plugins will be static
# if Qt is static.
if(NOT BUILD_SHARED_LIBS OR QT_IS_STATIC)
  set(STATIC_PLUGINS ON)
  add_definitions(-DQT_STATICPLUGIN)
  set(PLUGIN_TYPE "STATIC")
else()
  set(PLUGIN_TYPE "MODULE")
endif()

set(QCA_SUFFIX "${QCA_SUFFIX}" CACHE STRING "QCA common suffix")
if(QCA_SUFFIX)
  set(QCA_LIB_NAME qca-${QCA_SUFFIX})
  set(QCA_TOOL_NAME qcatool-${QCA_SUFFIX})
  set(MOZCERTS_NAME mozcerts-${QCA_SUFFIX})
  set(QCA_PC_NAME qca2-${QCA_SUFFIX}.pc)
  set(QCA_CONFIG_NAME_BASE "Qca-${QCA_SUFFIX}")
else()
  set(QCA_LIB_NAME qca)
  set(QCA_TOOL_NAME qcatool)
  set(MOZCERTS_NAME mozcerts)
  set(QCA_PC_NAME qca2.pc)
  set(QCA_CONFIG_NAME_BASE "Qca")
endif()

set(QCA_LIB_VERSION_STRING "${QCA_LIB_MAJOR_VERSION}.${QCA_LIB_MINOR_VERSION}.${QCA_LIB_PATCH_VERSION}")

configure_file("include/QtCrypto/qca_version.h.in" "${CMAKE_BINARY_DIR}/qca_version.h")

if (WIN32)
 set(CMAKE_DEBUG_POSTFIX "d")
 add_definitions(-DWIN32_LEAN_AND_MEAN)
elseif (APPLE)
 set(CMAKE_DEBUG_POSTFIX "_debug")
endif()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   if (CMAKE_SYSTEM_NAME MATCHES Linux)
     add_definitions (-D_DEFAULT_SOURCE)
     # on arm -Wcast-align throws many internal qt warning
     if(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "^arm")
       set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-align")
       set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-align")
     endif()

     set ( CMAKE_C_FLAGS     "${CMAKE_C_FLAGS} -Wno-long-long -Wundef -Werror-implicit-function-declaration -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -Wmissing-format-attribute -fno-common")
     set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -Wundef -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -fno-check-new -fno-common")

     if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
       set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-override -Wlogical-op" )
     endif()
   endif()
endif()

add_definitions(-DQT_NO_CAST_TO_ASCII
                -DQT_NO_CAST_FROM_ASCII
                -DQT_NO_URL_CAST_FROM_STRING
                -DQT_NO_CAST_FROM_BYTEARRAY
                -DQT_NO_SIGNALS_SLOTS_KEYWORDS
                -DQT_USE_QSTRINGBUILDER
                -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT)

if (NOT WIN32)
    # Strict iterators can't be used on Windows, they lead to a link error
    # when application code iterates over a QVector<QPoint> for instance, unless
    # Qt itself was also built with strict iterators.
    # See example at https://bugreports.qt.io/browse/AUTOSUITE-946
    add_definitions(-DQT_STRICT_ITERATORS)
endif()

include_directories("include/QtCrypto/")
# for generated files
include_directories(${CMAKE_BINARY_DIR})

if(NOT DEVELOPER_MODE)
  # uninstall target
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

  add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

# Always include srcdir and builddir in include path
# This saves typing ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY} in about every subdir
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# put the include dirs which are in the source or build tree
# before all other include dirs, so the headers in the sources
# are prefered over the already installed ones
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

set(qca_INCLUDEDIR "${CMAKE_CURRENT_SOURCE_DIR}/include" )

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin" )
# Use the same path for shared and static library
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib" )
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib" )

if( QCA_INSTALL_IN_QT_PREFIX )
  set(QCA_PREFIX_INSTALL_DIR "${QT_PREFIX_DIR}" CACHE PATH "Directory where qca will install")
  set(QCA_PLUGINS_INSTALL_DIR "${QT_PLUGINS_DIR}" CACHE PATH "Directory where qca plugins will install")
  set(QCA_BINARY_INSTALL_DIR "${QT_BINARY_DIR}" CACHE PATH "Directory where qca plugins will install")
  set(QCA_LIBRARY_INSTALL_DIR "${QT_LIBRARY_DIR}" CACHE PATH "Directory where qca library will install")
  set(QCA_FEATURE_INSTALL_DIR "${QT_MKSPECS_DIR}/features" CACHE PATH "Directory where qca feature file will install")
  if(NOT QCA_SUFFIX)
    set(QCA_INCLUDE_INSTALL_DIR "${QT_HEADERS_DIR}" CACHE PATH "Directory where qca public headers will install")
    set(QCA_PRIVATE_INCLUDE_INSTALL_DIR "${QT_HEADERS_DIR}" CACHE PATH "Directory where qca headers will install")
  else()
    set(QCA_INCLUDE_INSTALL_DIR "${QT_HEADERS_DIR}/${QCA_CONFIG_NAME_BASE}" CACHE PATH "Directory where qca public headers will install")
    set(QCA_PRIVATE_INCLUDE_INSTALL_DIR "${QT_HEADERS_DIR}/${QCA_CONFIG_NAME_BASE}" CACHE PATH "Directory where qca headers will install")
  endif()
  set(QCA_DOC_INSTALL_DIR "${QT_DOC_DIR}/html/qca/" CACHE PATH "Directory where qca documentation will install")
  set(QCA_MAN_INSTALL_DIR "${QT_DATA_DIR}/man" CACHE PATH "Directory where qca man pages will install")
else()
  # Cmake says nothing about LIB_SUFFIX
  # de facto it is a standard way to specify lib suffix on many distros
  set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
  set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE PATH "Directory where lib will install")

  set(QCA_PREFIX_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}" CACHE PATH "Directory where qca will install")
  set(QCA_PLUGINS_INSTALL_DIR "${LIB_INSTALL_DIR}/${QCA_LIB_NAME}" CACHE PATH "Directory where qca plugins will install")
  set(QCA_BINARY_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Directory where qca plugins will install")
  set(QCA_LIBRARY_INSTALL_DIR "${LIB_INSTALL_DIR}" CACHE PATH "Directory where qca library will install")
  set(QCA_FEATURE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/mkspecs/features" CACHE PATH "Directory where qca feature file will install")
  if(NOT QCA_SUFFIX)
    set(QCA_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "Directory where qca public headers will install")
    set(QCA_PRIVATE_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include" CACHE PATH "Directory where qca headers will install")
  else()
    set(QCA_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/${QCA_CONFIG_NAME_BASE}" CACHE PATH "Directory where qca public headers will install")
    set(QCA_PRIVATE_INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/${QCA_CONFIG_NAME_BASE}" CACHE PATH "Directory where qca headers will install")
  endif()
  set(QCA_DOC_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/doc/${QCA_LIB_NAME}/html" CACHE PATH "Directory where qca documentation will install")
  set(QCA_MAN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/man" CACHE PATH "Directory where qca man pages will install")
endif()

set(PKGCONFIG_INSTALL_PREFIX "${QCA_LIBRARY_INSTALL_DIR}/pkgconfig" CACHE PATH "Base directory for pkgconfig files")

normalize_path(QCA_PREFIX_INSTALL_DIR)

if(OSX_FRAMEWORK)
  set(QCA_FULL_INCLUDE_INSTALL_DIR "${QCA_LIBRARY_INSTALL_DIR}/${QCA_LIB_NAME}.framework/Headers")
else()
  set(QCA_FULL_INCLUDE_INSTALL_DIR "${QCA_INCLUDE_INSTALL_DIR}/QtCrypto")
endif()

# check for oportunity to use relative paths
option(USE_RELATIVE_PATHS "Try to make relocatable package")

foreach(PATH QCA_PLUGINS_INSTALL_DIR
             QCA_BINARY_INSTALL_DIR
             QCA_LIBRARY_INSTALL_DIR
             QCA_FEATURE_INSTALL_DIR
             QCA_INCLUDE_INSTALL_DIR
             QCA_PRIVATE_INCLUDE_INSTALL_DIR
             QCA_DOC_INSTALL_DIR
             QCA_MAN_INSTALL_DIR
             PKGCONFIG_INSTALL_PREFIX)

  # Normalize path before comparsion
  normalize_path(${PATH})

  # if all paths are subdirs of CMAKE_INSTALL_PREFIX it is possible to use relative paths
  string(FIND "${${PATH}}" "${QCA_PREFIX_INSTALL_DIR}/" POS)
  if(NOT "${POS}" STREQUAL "0")
    set(USE_RELATIVE_PATHS OFF)
  endif()
endforeach()

if(NOT WIN32)
  if(OSX_FRAMEWORK)
    set(PKGCONFIG_CFLAGS "-F\${libdir} -I\${includedir}")
    set(PKGCONFIG_LIBS "-F\${libdir} -framework ${QCA_LIB_NAME}")
  else()
    set(PKGCONFIG_CFLAGS "-I\${includedir}")
    set(PKGCONFIG_LIBS "-L\${libdir} -l${QCA_LIB_NAME}")
  endif()

  # qca2.pc uses absolute paths. So it must be there. Don't rellocate this.
  configure_file("qca2.pc.cmake" "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/pkgconfig/${QCA_PC_NAME}" @ONLY)
  if(NOT DEVELOPER_MODE)
    install(FILES "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/pkgconfig/${QCA_PC_NAME}" DESTINATION ${PKGCONFIG_INSTALL_PREFIX})
  endif()
endif()

# strip CMAKE_INSTALL_PREFIX in all paths
if(USE_RELATIVE_PATHS)
  message(STATUS "Installed package is relocatable")
  file(RELATIVE_PATH CRYPTO_PRF_RELATIVE_PATH "${QCA_FEATURE_INSTALL_DIR}" ${CMAKE_INSTALL_PREFIX})
  set(CRYPTO_PRF_RELATIVE_PATH "$$PWD/${CRYPTO_PRF_RELATIVE_PATH}")
  foreach(PATH QCA_PLUGINS_INSTALL_DIR
               QCA_BINARY_INSTALL_DIR
               QCA_LIBRARY_INSTALL_DIR
               QCA_FEATURE_INSTALL_DIR
               QCA_INCLUDE_INSTALL_DIR
               QCA_PRIVATE_INCLUDE_INSTALL_DIR
               QCA_DOC_INSTALL_DIR
               QCA_MAN_INSTALL_DIR
               PKGCONFIG_INSTALL_PREFIX)

     file(RELATIVE_PATH ${PATH} ${CMAKE_INSTALL_PREFIX} "${${PATH}}")
  endforeach()
else()
  message(STATUS "Installed package is NOT relocatable")
  set(CRYPTO_PRF_RELATIVE_PATH "")
endif()

if(DEVELOPER_MODE)
  add_definitions(-DDEVELOPER_MODE)

# To prefer plugins from build tree when run qca from build tree
  file(WRITE ${CMAKE_BINARY_DIR}/bin/qt.conf
"[Paths]
Plugins=${CMAKE_BINARY_DIR}/lib/${QCA_LIB_NAME}
")
endif()

if (APPLE)
   set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
endif()

message(STATUS "Checking for certstore..")
# fixme add OR mac
if( WIN32 )
    # USE BUILTIN
else()
  if ( DEFINED ENV{QC_CERTSTORE_PATH} )
    if(EXISTS $ENV{QC_CERTSTORE_PATH})
      set( qca_CERTSTORE $ENV{QC_CERTSTORE_PATH})
    endif()
  else()
    set( toTry
      "/etc/ssl/certs/ca-certificates.crt"
      "/usr/share/ssl/cert.pem"
      "/usr/share/ssl/certs/ca-bundle.crt"
      "/etc/pki/tls/cert.pem"
      "/etc/ssl/ca-bundle.pem"
      "/usr/share/curl/curl-ca-bundle.crt"
    )
    foreach (_current_try ${toTry})
      if(EXISTS ${_current_try})
        set( qca_CERTSTORE ${_current_try})
      endif()
    endforeach (_current_try)
  endif()
endif()

=== examples/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")
find_package(Qt5 REQUIRED Network)
add_subdirectory(aes-cmac)
add_subdirectory(base64test)
add_subdirectory(certtest)
add_subdirectory(ciphertest)
add_subdirectory(cms)
# this is not meant to be added, because it introduces
# a dependency on QtGui.
# add_subdirectory(cmssigner)
add_subdirectory(eventhandlerdemo)
add_subdirectory(hashtest)
add_subdirectory(hextest)
add_subdirectory(keyloader)
add_subdirectory(mactest)
add_subdirectory(md5crypt)
add_subdirectory(providertest)
add_subdirectory(publickeyexample)
add_subdirectory(randomtest)
add_subdirectory(rsatest)
add_subdirectory(saslclient)
add_subdirectory(saslserver)
add_subdirectory(ssltest)
add_subdirectory(sslservtest)
add_subdirectory(tlssocket)

=== src/CMakeLists.txt ===
include(CheckIncludeFiles)
CHECK_INCLUDE_FILES(sys/filio.h HAVE_SYS_FILIO_H)
IF(HAVE_SYS_FILIO_H)
  ADD_DEFINITIONS(-DHAVE_SYS_FILIO_H)
ENDIF(HAVE_SYS_FILIO_H)

INCLUDE(CheckCXXSourceCompiles)
CHECK_CXX_SOURCE_COMPILES("
# include <stdlib.h>
# include <sys/mman.h>
int main() { void *f = 0; return mlock(f,8); }
" MLOCK_TAKES_VOID)
if(NOT MLOCK_TAKES_VOID)
  MESSAGE(STATUS "mlock(2) does not take a void *")
  ADD_DEFINITIONS(-DMLOCK_NOT_VOID_PTR)
endif()

if(DEVELOPER_MODE)
  add_definitions(-DQCA_PLUGIN_PATH="${CMAKE_BINARY_DIR}/lib/${QCA_LIB_NAME}")
else()
  if(USE_RELATIVE_PATHS)
    add_definitions(-DQCA_PLUGIN_PATH="${QCA_PREFIX_INSTALL_DIR}/${QCA_PLUGINS_INSTALL_DIR}")
  else()
    add_definitions(-DQCA_PLUGIN_PATH="${QCA_PLUGINS_INSTALL_DIR}")
  endif()
endif()

# base source files


SET( SOURCES
	qca_tools.cpp
	qca_plugin.cpp
	qca_textfilter.cpp
	qca_basic.cpp
	support/logger.cpp
	qca_cert.cpp
	qca_core.cpp
	qca_default.cpp
	qca_keystore.cpp
	qca_publickey.cpp
	qca_safeobj.cpp
	qca_safetimer.cpp
	qca_securelayer.cpp
	qca_securemessage.cpp
	support/qpipe.cpp
	support/console.cpp
	support/synchronizer.cpp
	support/dirwatch.cpp
	support/syncthread.cpp
)

IF (WIN32)
  SET( SOURCES ${SOURCES} qca_systemstore_win.cpp )
elseif(APPLE)
  set( SOURCES ${SOURCES} qca_systemstore_mac.cpp)
else()
  SET( SOURCES ${SOURCES} qca_systemstore_flatfile.cpp )
endif()

# Support files
#SET( qca_HEADERS ${qca_HEADERS} support/dirwatch/dirwatch_p.h )

# Botan tools
SET( botan_BASE botantools/botan )


INCLUDE_DIRECTORIES(support ${botan_BASE} )

ADD_DEFINITIONS(
	-DBOTAN_TYPES_QT
	-DBOTAN_NO_INIT_H
	-DBOTAN_NO_CONF_H
	-DBOTAN_TOOLS_ONLY
	-DBOTAN_MINIMAL_BIGINT
)

ADD_DEFINITIONS(
  -DBOTAN_MP_WORD_BITS=32
  -DBOTAN_KARAT_MUL_THRESHOLD=12
  -DBOTAN_KARAT_SQR_THRESHOLD=12
  -DBOTAN_EXT_MUTEX_QT
)

if(UNIX)
   ADD_DEFINITIONS( -DBOTAN_EXT_ALLOC_MMAP)
endif()

SET( botan_SOURCES
	${botan_BASE}/util.cpp
	${botan_BASE}/exceptn.cpp
	${botan_BASE}/mutex.cpp
	${botan_BASE}/mux_qt/mux_qt.cpp
	${botan_BASE}/charset.cpp
	${botan_BASE}/defalloc.cpp
	${botan_BASE}/mp_comba.cpp
	${botan_BASE}/mp_mul.cpp
	${botan_BASE}/mp_shift.cpp
	${botan_BASE}/mp_misc.cpp
	${botan_BASE}/divide.cpp
	${botan_BASE}/big_base.cpp
	${botan_BASE}/big_code.cpp
	${botan_BASE}/big_io.cpp
	${botan_BASE}/big_ops2.cpp
	${botan_BASE}/big_ops3.cpp
	${botan_BASE}/bit_ops.cpp
	${botan_BASE}/libstate.cpp
	${botan_BASE}/mem_pool.cpp
	${botan_BASE}/modules.cpp
	${botan_BASE}/mp_asm.cpp
	${botan_BASE}/mp_mulop.cpp
	${botan_BASE}/parsing.cpp
)

IF (UNIX)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/ml_unix/mlock.cpp)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/alloc_mmap/mmap_mem.cpp)
ENDIF (UNIX)

IF(WIN32)
  SET( botan_SOURCES ${botan_SOURCES} ${botan_BASE}/ml_win32/mlock.cpp)
ENDIF(WIN32)

SET( SOURCES ${SOURCES} ${botan_SOURCES})

add_library(${QCA_LIB_NAME} ${SOURCES}  ${public_HEADERS})
TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} Qt5::Core)

if(WIN32)
	TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} crypt32 ws2_32)
endif()

if(APPLE)
  set(COREFOUNDATION_LIBRARY "-framework CoreFoundation")
  set(COREFOUNDATION_LIBRARY_SECURITY "-framework Security")
  TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} ${COREFOUNDATION_LIBRARY} ${COREFOUNDATION_LIBRARY_SECURITY})

  if(NOT USE_RELATIVE_PATHS)
    set_target_properties(${QCA_LIB_NAME} PROPERTIES
                          INSTALL_NAME_DIR "${QCA_LIBRARY_INSTALL_DIR}"
    )
  endif()
endif()

if(NOT ANDROID)
  set_target_properties(${QCA_LIB_NAME} PROPERTIES
                        VERSION ${QCA_LIB_MAJOR_VERSION}.${QCA_LIB_MINOR_VERSION}.${QCA_LIB_PATCH_VERSION}
                        SOVERSION ${QCA_LIB_MAJOR_VERSION}
                        )
endif()

set_target_properties(${QCA_LIB_NAME} PROPERTIES
                      DEFINE_SYMBOL QCA_MAKEDLL
                      PUBLIC_HEADER "${public_HEADERS}"
                      FRAMEWORK ${OSX_FRAMEWORK}
                      FRAMEWORK_VERSION ${QCA_LIB_MAJOR_VERSION}
                      EXPORT_NAME ${QCA_LIB_NAME}
                      )

if(NOT DEVELOPER_MODE)
  # Do not split 'PUBLIC_HEADER ...' line. It means install headers to folder
  # and set this folder as -I flag for imported target.
  # Also EXPORT doesn't actually install any files. It only created a new target.
  install(TARGETS ${QCA_LIB_NAME} EXPORT ${QCA_CONFIG_NAME_BASE}Targets
          LIBRARY DESTINATION "${QCA_LIBRARY_INSTALL_DIR}"
          RUNTIME DESTINATION "${QCA_BINARY_INSTALL_DIR}"
          ARCHIVE DESTINATION "${QCA_LIBRARY_INSTALL_DIR}"
          FRAMEWORK DESTINATION "${QCA_LIBRARY_INSTALL_DIR}"
          PUBLIC_HEADER DESTINATION "${QCA_FULL_INCLUDE_INSTALL_DIR}" INCLUDES DESTINATION "${QCA_FULL_INCLUDE_INSTALL_DIR}"
  )
  install_pdb(${QCA_LIB_NAME} ${QCA_BINARY_INSTALL_DIR})
endif()

=== unittest/CMakeLists.txt ===
ENABLE_TESTING()
find_package(Qt5 REQUIRED Test)
# QTEST_MAIN is using QApplication when QT_GUI_LIB is defined
remove_definitions(-DQT_GUI_LIB)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")

add_subdirectory(base64unittest)
add_subdirectory(bigintunittest)
add_subdirectory(certunittest)
add_subdirectory(cipherunittest)
add_subdirectory(clientplugin)
add_subdirectory(cms)
add_subdirectory(dsaunittest)
add_subdirectory(filewatchunittest)
add_subdirectory(hashunittest)
add_subdirectory(hexunittest)
add_subdirectory(kdfunittest)
add_subdirectory(keybundle)
add_subdirectory(keygenunittest)
add_subdirectory(keylengthunittest)
add_subdirectory(keystore)
add_subdirectory(logger)
add_subdirectory(macunittest)
add_subdirectory(metatype)
add_subdirectory(pgpunittest)
add_subdirectory(pipeunittest)
add_subdirectory(pkits)
add_subdirectory(rsaunittest)
add_subdirectory(securearrayunittest)
add_subdirectory(staticunittest)
add_subdirectory(symmetrickeyunittest)
add_subdirectory(tls)
add_subdirectory(velox)

=== examples/eventhandlerdemo/CMakeLists.txt ===
set(eventhandlerdemo_bin_SRCS eventhandlerdemo.cpp)  

add_executable(eventhandlerdemo ${eventhandlerdemo_bin_SRCS})

target_link_qca_libraries(eventhandlerdemo)

=== examples/keyloader/CMakeLists.txt ===
set(keyloader_bin_SRCS keyloader.cpp)  

add_executable(keyloader ${keyloader_bin_SRCS})

target_link_qca_libraries(keyloader)

=== examples/saslserver/CMakeLists.txt ===
set(saslserver_bin_SRCS saslserver.cpp)  

add_executable(saslserver ${saslserver_bin_SRCS})

target_link_qca_libraries(saslserver)
target_link_libraries(saslserver Qt5::Network)

=== examples/sslservtest/CMakeLists.txt ===
set(sslservtest_bin_SRCS sslservtest.cpp)  

add_executable(sslservtest ${sslservtest_bin_SRCS})

target_link_qca_libraries(sslservtest)
target_link_libraries(sslservtest Qt5::Network)

=== examples/ssltest/CMakeLists.txt ===
set(ssltest_bin_SRCS ssltest.cpp)  

add_executable(ssltest ${ssltest_bin_SRCS})

target_link_qca_libraries(ssltest)
target_link_libraries(ssltest Qt5::Network)

=== examples/tlssocket/CMakeLists.txt ===
add_executable(tlssocket tlssocket.cpp main.cpp)

target_link_qca_libraries(tlssocket)
target_link_libraries(tlssocket Qt5::Network)

=== plugins/qca-botan/CMakeLists.txt ===
find_package(PkgConfig REQUIRED)
if(WITH_botan_PLUGIN STREQUAL "yes")
  pkg_check_modules(BOTAN REQUIRED IMPORTED_TARGET botan-2)
else()
  pkg_check_modules(BOTAN IMPORTED_TARGET botan-2)
endif()

if(BOTAN_FOUND)
  enable_plugin("botan")

  set(QCA_BOTAN_SOURCES qca-botan.cpp)
  add_library(qca-botan ${PLUGIN_TYPE} ${QCA_BOTAN_SOURCES})

  if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
    set_property(TARGET qca-botan  PROPERTY SUFFIX ".dylib")
  endif()

  target_link_libraries(qca-botan Qt5::Core ${QCA_LIB_NAME} PkgConfig::BOTAN)

  if(NOT DEVELOPER_MODE)
    install(TARGETS qca-botan
            LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

    install_pdb(qca-botan ${QCA_CRYPTO_INSTALL_DIR})
  endif()

else()
  disable_plugin("botan")
endif()

=== plugins/qca-cyrus-sasl/CMakeLists.txt ===
if(WITH_cyrus-sasl_PLUGIN STREQUAL "yes")
  find_package(Sasl2 REQUIRED)
else()
  find_package(Sasl2)
endif()

if(SASL2_FOUND)
  enable_plugin("cyrus-sasl")

  set(QCA_SASL_SOURCES qca-cyrus-sasl.cpp)
  include_directories( ${SASL2_INCLUDE_DIR} )
  add_library(qca-cyrus-sasl ${PLUGIN_TYPE} ${QCA_SASL_SOURCES})

  if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
    set_property(TARGET qca-cyrus-sasl PROPERTY SUFFIX ".dylib")
  endif()

  target_link_libraries(qca-cyrus-sasl Qt5::Core ${QCA_LIB_NAME} ${SASL2_LIBRARIES})

  if(NOT DEVELOPER_MODE)
    install(TARGETS qca-cyrus-sasl
            LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

    install_pdb(qca-cyrus-sasl ${QCA_CRYPTO_INSTALL_DIR})
  endif()
else()
  disable_plugin("cyrus-sasl")
endif()

=== debian/changelog ===
qca2 (2.3.2-2) unstable; urgency=medium

  * Team upload.
  * Drop patch hurd_msync.diff, as now Hurd implements msync().
  * Drop patch kubuntu_ignore_filewatch_test.diff, as this test seems to work
    fine now.
  * Use $AUTOPKGTEST_TMP instead of $ADTTMP in autopkgtests.
  * Do not ship the upstream README in libqca-qt5-2, as it is not much of use.

 -- Pino Toscano <pino@debian.org>  Sun, 07 Feb 2021 10:58:31 +0100

qca2 (2.3.2-1) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Fix day-of-week for changelog entry 1.0-1.

  [ Pino Toscano ]
  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump Qt5 to 5.9
  * Bump Standards-Version to 4.5.1, no changes required.
  * Update the patches:
    - define_qca_export.diff: refresh
    - pipeunittest_more_wait.diff: refresh
    - hurd_msync.diff: refresh
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13

 -- Pino Toscano <pino@debian.org>  Fri, 05 Feb 2021 00:43:58 +0100

=== debian/control ===
--- 
+++ 
@@ -6,16 +6,16 @@
            Maximiliano Curia <maxy@debian.org>,
 Build-Depends: ca-certificates,
                cmake (>= 3.4~),
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libsasl2-dev,
                libssl-dev (>= 1.1.1~),
                pkg-config,
                pkg-kde-tools (>= 0.15.16),
-               qtbase5-dev (>= 5.6.0~),
+               qtbase5-dev (>= 5.9.0~),
 Build-Depends-Indep: doxygen,
                      graphviz,
 Build-Conflicts: libqca2-dev, qca-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://userbase.kde.org/QCA
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qca2.git

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_CFLAGS_MAINT_APPEND = -fvisibility=hidden -fvisibility-inlines-hidden
export DEB_CXXFLAGS_MAINT_APPEND = -fvisibility=hidden -fvisibility-inlines-hidden

# Enable strict interdependencies
libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages)
include /usr/share/pkg-kde-tools/qt-kde-team/3/library-packages.mk

%:
	dh $@ --builddirectory=build

override_dh_auto_configure:
	QT_SELECT=qt5 dh_auto_configure --builddirectory=build -- \
	    -DQT5_BUILD=ON -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
	    -DQCA_FEATURE_INSTALL_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/qt5/mkspecs/features"

override_dh_auto_build-arch:
	dh_auto_build --builddirectory=build

override_dh_auto_build-indep:
	dh_auto_build --builddirectory=build -- doc
	find build/apidocs/html -name '*.md5' -delete

override_dh_auto_install-indep:

override_dh_auto_test-indep:

override_dh_strip:
	dh_strip --dbgsym-migration='libqca-qt5-2-dbg (<< 2.1.3-2~)'

override_dh_gencontrol-arch: libpkgs_gen_strict_local_shlibs
	dh_gencontrol -a

=== debian/watch ===
version=4
opts=pgpmode=auto https://download.kde.org/stable/qca/([\d.]+)/qca-([\d.]+)\.tar\.xz

## qca2 2.3.3

=== debian/changelog ===
qca2 (2.3.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump Qt5 to 5.14
  * Drop the migration from libqca-qt5-2-dbg, no more needed after two Debian
    stable releases.

 -- Pino Toscano <pino@debian.org>  Sat, 28 Aug 2021 08:25:41 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                libssl-dev (>= 1.1.1~),
                pkg-config,
                pkg-kde-tools (>= 0.15.16),
-               qtbase5-dev (>= 5.9.0~),
+               qtbase5-dev (>= 5.14.0~),
 Build-Depends-Indep: doxygen,
                      graphviz,
 Build-Conflicts: libqca2-dev, qca-dev

## qca2 2.3.4

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,9 @@
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")
-find_package(Qt5 REQUIRED Network)
+if(QT6)
+  find_package(Qt6 REQUIRED Network)
+else()
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")
+  find_package(Qt5 REQUIRED Network)
+endif()
 add_subdirectory(aes-cmac)
 add_subdirectory(base64test)
 add_subdirectory(certtest)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -124,7 +124,11 @@
 SET( SOURCES ${SOURCES} ${botan_SOURCES})
 
 add_library(${QCA_LIB_NAME} ${SOURCES}  ${public_HEADERS})
-TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} Qt5::Core)
+if(QT6)
+  target_link_libraries(${QCA_LIB_NAME} Qt6::Core Qt6::Core5Compat)
+else()
+  target_link_libraries(${QCA_LIB_NAME} Qt5::Core)
+endif()
 
 if(WIN32)
 	TARGET_LINK_LIBRARIES(${QCA_LIB_NAME} crypt32 ws2_32)

=== examples/saslserver/CMakeLists.txt ===
set(saslserver_bin_SRCS saslserver.cpp)  

add_executable(saslserver ${saslserver_bin_SRCS})

target_link_qca_libraries(saslserver)
if(QT6)
  target_link_libraries(saslserver Qt6::Network)
else()
  target_link_libraries(saslserver Qt5::Network)
endif()

=== examples/sslservtest/CMakeLists.txt ===
set(sslservtest_bin_SRCS sslservtest.cpp)  

add_executable(sslservtest ${sslservtest_bin_SRCS})

target_link_qca_libraries(sslservtest)
if(QT6)
  target_link_libraries(sslservtest Qt6::Network)
else()
  target_link_libraries(sslservtest Qt5::Network)
endif()

=== examples/ssltest/CMakeLists.txt ===
set(ssltest_bin_SRCS ssltest.cpp)  

add_executable(ssltest ${ssltest_bin_SRCS})

target_link_qca_libraries(ssltest)
if(QT6)
  target_link_libraries(ssltest Qt6::Network)
else()
  target_link_libraries(ssltest Qt5::Network)
endif()

=== examples/tlssocket/CMakeLists.txt ===
add_executable(tlssocket tlssocket.cpp main.cpp)

target_link_qca_libraries(tlssocket)
if(QT6)
  target_link_libraries(tlssocket Qt6::Network)
else()
  target_link_libraries(tlssocket Qt5::Network)
endif()

=== plugins/qca-gcrypt/CMakeLists.txt ===
if(WITH_gcrypt_PLUGIN STREQUAL "yes")
  find_package(LibGcrypt REQUIRED)
else()
  find_package(LibGcrypt)
endif()

if(LIBGCRYPT_FOUND)
  include(CheckTypeSize)

  set(remember_includes ${CMAKE_EXTRA_INCLUDE_FILES})
  set(remember_defines ${CMAKE_REQUIRED_FLAGS})
  set(CMAKE_EXTRA_INCLUDE_FILES gcrypt.h)
  set(CMAKE_REQUIRED_FLAGS ${LIBGCRYPT_CFLAGS})
  check_type_size(gcry_error_t GCRY_ERROR_T)
  set(CMAKE_REQUIRED_FLAGS ${remember_defines})
  set(CMAKE_EXTRA_INCLUDE_FILES ${remember_includes})
  if(HAVE_GCRY_ERROR_T)
    enable_plugin("gcrypt")

    set(QCA_GCRYPT_SOURCES qca-gcrypt.cpp)
    add_definitions(${LIBGCRYPT_CFLAGS})
    add_library(qca-gcrypt ${PLUGIN_TYPE} ${QCA_GCRYPT_SOURCES})

    if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
      set_property(TARGET qca-gcrypt PROPERTY SUFFIX ".dylib")
    endif()

    if(QT6)
      target_link_libraries(qca-gcrypt Qt6::Core ${QCA_LIB_NAME} ${LIBGCRYPT_LIBRARIES})
    else()
      target_link_libraries(qca-gcrypt Qt5::Core ${QCA_LIB_NAME} ${LIBGCRYPT_LIBRARIES})
    endif()

    if(NOT DEVELOPER_MODE)
      install(TARGETS qca-gcrypt
              LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
              ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
              RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

      install_pdb(qca-gcrypt ${QCA_CRYPTO_INSTALL_DIR})
    endif()
  else()
    message(STATUS "libgcrypt seems to be too old")
    disable_plugin("gcrypt")
  endif()
else()
  disable_plugin("gcrypt")
endif()

=== plugins/qca-gnupg/CMakeLists.txt ===
# QCA GnuPG

enable_plugin("gnupg")

set(QCA_GNUPG_SOURCES
  qca-gnupg.cpp
  gpgop.cpp
  utils.cpp
  gpgproc/sprocess.cpp
  mypgpkeycontext.cpp
  mykeystoreentry.cpp
  myopenpgpcontext.cpp
  mykeystorelist.cpp
  mymessagecontext.cpp
  ringwatch.cpp
  lineconverter.cpp
  gpgaction.cpp
  gpgproc/gpgproc.cpp
)

set(QCA_GNUPG_HEADERS
  gpgaction.h
  ringwatch.h
  gpgop.h
  gpgop_p.h
  lineconverter.h
  mypgpkeycontext.h
  mykeystoreentry.h
  mykeystorelist.h
  gpgproc/gpgproc_p.h
  gpgproc/sprocess.h
  gpgproc/gpgproc.h
  utils.h
  mymessagecontext.h
  myopenpgpcontext.h
)

add_library(qca-gnupg ${PLUGIN_TYPE} ${QCA_GNUPG_SOURCES} ${EXTRA_GNUPG_SOURCES} ${QCA_GNUPG_HEADERS})

if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
  set_property(TARGET qca-gnupg PROPERTY SUFFIX ".dylib")
endif()

include_directories(gpgproc)
if(QT6)
  target_link_libraries(qca-gnupg Qt6::Core ${QCA_LIB_NAME})
else()
  target_link_libraries(qca-gnupg Qt5::Core ${QCA_LIB_NAME})
endif()

if (WIN32)
  target_link_libraries(qca-gnupg advapi32)
endif()

if(NOT DEVELOPER_MODE)
  install(TARGETS qca-gnupg DESTINATION
          LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
          ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
          RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

  install_pdb(qca-gnupg ${QCA_CRYPTO_INSTALL_DIR})
endif()

=== plugins/qca-ossl/CMakeLists.txt ===
# QCA OSSL

if(WITH_ossl_PLUGIN STREQUAL "yes")
  find_package(OpenSSL 1.1.1 REQUIRED)
else()
  find_package(OpenSSL 1.1.1)
endif()

if(OPENSSL_FOUND)
  enable_plugin("ossl")

  include(CheckFunctionExists)
  set(CMAKE_REQUIRED_LIBRARIES ${OPENSSL_LIBRARIES})
  check_function_exists(EVP_md2 HAVE_OPENSSL_MD2)
  if(HAVE_OPENSSL_MD2)
    add_definitions(-DHAVE_OPENSSL_MD2)
  else()
    message(WARNING "qca-ossl will be compiled without MD2 digest algorithm support")
  endif()

  check_function_exists(EVP_aes_128_ctr HAVE_OPENSSL_AES_CTR)
  if(HAVE_OPENSSL_AES_CTR)
    add_definitions(-DHAVE_OPENSSL_AES_CTR)
  else()
    message(WARNING "qca-ossl will be compiled without AES CTR mode encryption support")
  endif()

  check_function_exists(EVP_aes_128_gcm HAVE_OPENSSL_AES_GCM)
  if(HAVE_OPENSSL_AES_GCM)
    add_definitions(-DHAVE_OPENSSL_AES_GCM)
  else()
    message(WARNING "qca-ossl will be compiled without AES GCM mode encryption support")
  endif()

  check_function_exists(EVP_aes_128_ccm HAVE_OPENSSL_AES_CCM)
  if(HAVE_OPENSSL_AES_CCM)
    add_definitions(-DHAVE_OPENSSL_AES_CCM)
  else()
    message(WARNING "qca-ossl will be compiled without AES CCM mode encryption support")
  endif()

  check_function_exists(EVP_sha HAVE_OPENSSL_SHA0)
  if(HAVE_OPENSSL_SHA0)
    add_definitions(-DHAVE_OPENSSL_SHA0)
  else()
    message(WARNING "qca-ossl will be compiled without SHA-0 digest algorithm support")
  endif()

  set(QCA_OSSL_SOURCES
      qca-ossl.cpp)

  add_library(qca-ossl ${PLUGIN_TYPE} ${QCA_OSSL_SOURCES})

  if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
    set_property(TARGET qca-ossl PROPERTY SUFFIX ".dylib")
  endif()

  if(QT6)
    target_link_libraries(qca-ossl Qt6::Core)
  else()
    target_link_libraries(qca-ossl Qt5::Core)
  endif()
  target_link_libraries(qca-ossl ${QCA_LIB_NAME})
  target_link_libraries(qca-ossl OpenSSL::SSL OpenSSL::Crypto)

  if(NOT DEVELOPER_MODE)
    install(TARGETS qca-ossl
            LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

    install_pdb(qca-ossl ${QCA_CRYPTO_INSTALL_DIR})
  endif()

else()
  disable_plugin("ossl")
endif()

=== plugins/qca-pkcs11/CMakeLists.txt ===
# qca-pkcs11

if(WITH_pkcs11_PLUGIN STREQUAL "yes")
  find_package(OpenSSL REQUIRED)
  find_package(Pkcs11Helper REQUIRED)
else()
  find_package(OpenSSL)
  find_package(Pkcs11Helper)
endif()

if(OPENSSL_FOUND AND PKCS11H_FOUND)
  enable_plugin("pkcs11")
  set(QCA_PKCS11_SOURCES qca-pkcs11.cpp)

  add_library(qca-pkcs11 ${PLUGIN_TYPE} ${QCA_PKCS11_SOURCES})

  if(APPLE AND ${PLUGIN_TYPE} STREQUAL "MODULE")
    set_property(TARGET qca-pkcs11 PROPERTY SUFFIX ".dylib")
  endif()

  add_definitions(${PKCS11H_CFLAGS_OTHER})
  include_directories(${PKCS11H_INCLUDE_DIRS})
  if(QT6)
    target_link_libraries(qca-pkcs11 Qt6::Core)
  else()
    target_link_libraries(qca-pkcs11 Qt5::Core)
  endif()
  target_link_libraries(qca-pkcs11 ${QCA_LIB_NAME})
  target_link_libraries(qca-pkcs11 ${PKCS11H_LDFLAGS})
  if (WIN32)
    target_link_libraries(qca-pkcs11 pkcs11-helper.dll)
  endif()

  if(NOT DEVELOPER_MODE)
    install(TARGETS qca-pkcs11
            LIBRARY DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            ARCHIVE DESTINATION "${QCA_CRYPTO_INSTALL_DIR}"
            RUNTIME DESTINATION "${QCA_CRYPTO_INSTALL_DIR}")

    install_pdb(qca-pkcs11 ${QCA_CRYPTO_INSTALL_DIR})
  endif()
else()
  disable_plugin("pkcs11")
endif()

=== tools/qcatool/CMakeLists.txt ===
project(qcatool)

set(qcatool_bin_SRCS main.cpp)

add_executable(${QCA_TOOL_NAME} ${qcatool_bin_SRCS})

target_link_qca_libraries(${QCA_TOOL_NAME})

if(NOT DEVELOPER_MODE)
  install(TARGETS ${QCA_TOOL_NAME} DESTINATION "${QCA_BINARY_INSTALL_DIR}")
  install_pdb(${QCA_TOOL_NAME} ${QCA_BINARY_INSTALL_DIR})
endif()

=== unittest/rsaunittest/CMakeLists.txt ===
ENABLE_TESTING()

set(rsaunittest_bin_SRCS rsaunittest.cpp)  

add_executable(rsaunittest ${rsaunittest_bin_SRCS} )

target_link_qca_test_libraries(rsaunittest)

add_qca_test(rsaunittest "RSA")

=== debian/changelog ===
qca2 (2.3.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.6.0, no changes required.
  * CI: disable the blhc job.

 -- Pino Toscano <pino@debian.org>  Thu, 16 Sep 2021 21:20:53 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 Build-Depends-Indep: doxygen,
                      graphviz,
 Build-Conflicts: libqca2-dev, qca-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://userbase.kde.org/QCA
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qca2.git

=== debian/rules ===
--- 
+++ 
@@ -28,8 +28,5 @@
 
 override_dh_auto_test-indep:
 
-override_dh_strip:
-	dh_strip --dbgsym-migration='libqca-qt5-2-dbg (<< 2.1.3-2~)'
-
 override_dh_gencontrol-arch: libpkgs_gen_strict_local_shlibs
 	dh_gencontrol -a
